searchNodes=[{"ref":"AFK.html","title":"AFK","type":"module","doc":"A library for modeling the internal state of a computer keyboard. See AFK.Keycode and AFK.Keymap to learn how to create keymaps with layers. Then see AFK.State to see how to initialize and manipulate the state."},{"ref":"AFK.Keycode.html","title":"AFK.Keycode","type":"module","doc":"A keycode represents a key that when pressed affects the keyboard state in some way. The currently supported keycode types are: AFK.Keycode.Key - A basic keyboard key AFK.Keycode.Layer - A key that can activate other layers AFK.Keycode.Modifier - A basic keyboard modifier AFK.Keycode.None - A keycode that does nothing AFK.Keycode.Transparent - A key that is transparent to its layer"},{"ref":"AFK.Keycode.html#t:t/0","title":"AFK.Keycode.t/0","type":"type","doc":""},{"ref":"AFK.Keycode.html#t:with_scancode/0","title":"AFK.Keycode.with_scancode/0","type":"type","doc":""},{"ref":"AFK.Keycode.Key.html","title":"AFK.Keycode.Key","type":"module","doc":"Represents a basic keyboard keycode, like letters, numbers, etc. All standard keys on a keyboard except the modifiers can be represented by Key keycodes. The currently supported keys are key/0."},{"ref":"AFK.Keycode.Key.html#new/1","title":"AFK.Keycode.Key.new/1","type":"function","doc":"Creates a basic key keycode. Examples iex&gt; new(:a) %AFK.Keycode.Key{key: :a} iex&gt; new(:up) %AFK.Keycode.Key{key: :up}"},{"ref":"AFK.Keycode.Key.html#t:key/0","title":"AFK.Keycode.Key.key/0","type":"type","doc":""},{"ref":"AFK.Keycode.Key.html#t:t/0","title":"AFK.Keycode.Key.t/0","type":"type","doc":""},{"ref":"AFK.Keycode.Layer.html","title":"AFK.Keycode.Layer","type":"module","doc":"Represents a key that can activate other layers on and off in various ways. Layers can be activated in 3 ways: :hold - Temporarily activates a layer while being held :toggle - Toggles a layer on or off when pressed :default - Sets a layer as the default layer"},{"ref":"AFK.Keycode.Layer.html#new/2","title":"AFK.Keycode.Layer.new/2","type":"function","doc":"Creates a layer activation keycode. The valid types are: :hold - Activates a layer while being held :toggle - Toggles a layer on or off when pressed :default - Sets a layer as the default layer Examples iex&gt; new(:hold, 1) %AFK.Keycode.Layer{layer: 1, mode: :hold} iex&gt; new(:hold, 2) %AFK.Keycode.Layer{layer: 2, mode: :hold} iex&gt; new(:toggle, 1) %AFK.Keycode.Layer{layer: 1, mode: :toggle} iex&gt; new(:default, 2) %AFK.Keycode.Layer{layer: 2, mode: :default}"},{"ref":"AFK.Keycode.Layer.html#t:layer/0","title":"AFK.Keycode.Layer.layer/0","type":"type","doc":""},{"ref":"AFK.Keycode.Layer.html#t:mode/0","title":"AFK.Keycode.Layer.mode/0","type":"type","doc":""},{"ref":"AFK.Keycode.Layer.html#t:t/0","title":"AFK.Keycode.Layer.t/0","type":"type","doc":""},{"ref":"AFK.Keycode.Modifier.html","title":"AFK.Keycode.Modifier","type":"module","doc":"Represents a basic modifier keycode, like control, shift, etc. All standard modifiers on a keyboard can be represented by Modifier keycodes. The currently supported modifiers are modifier/0."},{"ref":"AFK.Keycode.Modifier.html#new/1","title":"AFK.Keycode.Modifier.new/1","type":"function","doc":"Creates a basic modifier keycode. Examples iex&gt; new(:left_control) %AFK.Keycode.Modifier{modifier: :left_control} iex&gt; new(:right_super) %AFK.Keycode.Modifier{modifier: :right_super}"},{"ref":"AFK.Keycode.Modifier.html#t:modifier/0","title":"AFK.Keycode.Modifier.modifier/0","type":"type","doc":""},{"ref":"AFK.Keycode.Modifier.html#t:t/0","title":"AFK.Keycode.Modifier.t/0","type":"type","doc":""},{"ref":"AFK.Keycode.None.html","title":"AFK.Keycode.None","type":"module","doc":"Represents a key that does nothing when pressed."},{"ref":"AFK.Keycode.None.html#new/0","title":"AFK.Keycode.None.new/0","type":"function","doc":"Creates a None keycode."},{"ref":"AFK.Keycode.None.html#t:t/0","title":"AFK.Keycode.None.t/0","type":"type","doc":""},{"ref":"AFK.Keycode.Transparent.html","title":"AFK.Keycode.Transparent","type":"module","doc":"Represents a key that is transparent to its layer. Any key-press it registers falls to lower layers, of any."},{"ref":"AFK.Keycode.Transparent.html#new/0","title":"AFK.Keycode.Transparent.new/0","type":"function","doc":"Creates a Transparent keycode."},{"ref":"AFK.Keycode.Transparent.html#t:t/0","title":"AFK.Keycode.Transparent.t/0","type":"type","doc":""},{"ref":"AFK.Keymap.html","title":"AFK.Keymap","type":"module","doc":"A keymap represents the virtual key layout of a keyboard. It can be made up of multiple layers that can be activated and deactivated by pressing AFK.Layer keycodes. A keymap just needs to be a list of maps, where each map is a mapping of physical key identifier (usually an atom), to a AFK.Keycode.Keycode. For example: [ # Layer 0 (default) %{ k001: AFK.Keycode.Key.new(:a), k002: AFK.Keycode.Modifier.new(:left_control), k003: AFK.Keycode.Layer.new(:hold, 1), k004: AFK.Keycode.Key.new(:caps_lock) }, # Layer 1 %{ k001: AFK.Keycode.Key.new(:z), k002: AFK.Keycode.Modifier.new(:right_super), k003: AFK.Keycode.None.new(), k004: AFK.Keycode.Transparent.new() } ]"},{"ref":"AFK.Keymap.html#load_from_file!/1","title":"AFK.Keymap.load_from_file!/1","type":"function","doc":"Loads a keymap from a file."},{"ref":"AFK.Keymap.html#save_to_file!/2","title":"AFK.Keymap.save_to_file!/2","type":"function","doc":"Saves a keymap to a file."},{"ref":"AFK.Keymap.html#t:layer/0","title":"AFK.Keymap.layer/0","type":"type","doc":""},{"ref":"AFK.Keymap.html#t:t/0","title":"AFK.Keymap.t/0","type":"type","doc":""},{"ref":"AFK.State.html","title":"AFK.State","type":"module","doc":"A struct representing the current state of the keyboard. The state is initialized with a list of physical key to keycode maps representing the desired layers. The first layer is assumed to be the active default. The keyboard state can be modified by calling press_key/2 and release_key/2 with physical key IDs. The state can then be turned into a HID report byte string using to_hid_report/1."},{"ref":"AFK.State.html#new/1","title":"AFK.State.new/1","type":"function","doc":"Returns a new state struct initialized with the given keymap."},{"ref":"AFK.State.html#press_key/2","title":"AFK.State.press_key/2","type":"function","doc":"Adds a key being pressed."},{"ref":"AFK.State.html#release_key/2","title":"AFK.State.release_key/2","type":"function","doc":"Releases a key being pressed."},{"ref":"AFK.State.html#to_hid_report/1","title":"AFK.State.to_hid_report/1","type":"function","doc":"Return the keyboard state to as a 6-key USB keyboard HID report."},{"ref":"AFK.State.html#t:t/0","title":"AFK.State.t/0","type":"type","doc":""},{"ref":"readme.html","title":"README","type":"extras","doc":"AFK A library for modeling the internal state of a computer keyboard. It supports arbitrary layouts with any number of layers, and outputs a basic 6-key HID report byte string. Its intended use is to model the state for keyboard firmware. A work-in-progress firmware using Nerves is being attempted over here."},{"ref":"readme.html#installation","title":"README - Installation","type":"extras","doc":"AFK can be installed by adding afk to your list of dependencies in mix.exs: def deps do [ {:afk, &quot;~&gt; 0.1.0&quot;} ] end"},{"ref":"readme.html#basic-usage","title":"README - Basic Usage","type":"extras","doc":"First, you define a keymap: keymap = [ # Layer 0 (default) %{ k001: AFK.Keycode.Key.new(:a), k002: AFK.Keycode.Modifier.new(:left_control), k003: AFK.Keycode.Layer.new(:hold, 1), k004: AFK.Keycode.Key.new(:caps_lock) }, # Layer 1 %{ k001: AFK.Keycode.Key.new(:z), k002: AFK.Keycode.Modifier.new(:right_super), k003: AFK.Keycode.None.new(), k004: AFK.Keycode.Transparent.new() } ] You can now initialize an AFK.State struct and press and release keys. Calling to_hid_report/1 returns a byte string for sending to a HID interface configured as a basic 6-key rollover USB keyboard. state = AFK.State.new(keymap) state = state |&gt; AFK.State.press_key(:k003) |&gt; AFK.State.press_key(:k002) |&gt; AFK.State.press_key(:k001) AFK.State.to_hid_report(state) # =&gt; &lt;&lt;128, 0, 29, 0, 0, 0, 0, 0&gt;&gt; state = AFK.State.release_key(state, :k002) AFK.State.to_hid_report(state) # =&gt; &lt;&lt;0, 0, 29, 0, 0, 0, 0, 0&gt;&gt;"},{"ref":"readme.html#future-features","title":"README - Future Features","type":"extras","doc":"It&#39;s intended to eventually support N-key rollover, but for now it just supports basic 6-key rollover. It may eventually also support more complex interactions, such as sticky keys, macros, leader keys, etc. These features require a lot more thinking though, as they will require a process that emits an event stream as opposed to the current data structure approach."},{"ref":"readme.html#docs","title":"README - Docs","type":"extras","doc":"Documentation can be found at https://hexdocs.pm/afk."},{"ref":"license.html","title":"LICENSE","type":"extras","doc":"MIT License Copyright 2019 Chris Dosé Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE."}]